Ext.data.JsonP.KISSY_Date_Formatter({"tagname":"class","name":"KISSY.Date.Formatter","autodetected":{},"files":[{"filename":"format.js","href":"format.html#KISSY-Date-Formatter"}],"params":[{"tagname":"params","type":"String","name":"pattern","doc":"<p>patter string of date formatter</p>\n\n<table border=\"1\">\n<thead valign=\"bottom\">\n<tr><th class=\"head\">Letter</th>\n<th class=\"head\">Date or Time Component</th>\n<th class=\"head\">Presentation</th>\n<th class=\"head\">Examples</th>\n</tr>\n</thead>\n<tbody valign=\"top\">\n<tr><td>G</td>\n<td>Era designator</td>\n<td>Text</td>\n<td>AD</td>\n</tr>\n<tr><td>y</td>\n<td>Year</td>\n<td>Year</td>\n<td>1996; 96</td>\n</tr>\n<tr><td>M</td>\n<td>Month in year</td>\n<td>Month</td>\n<td>July; Jul; 07</td>\n</tr>\n<tr><td>w</td>\n<td>Week in year</td>\n<td>Number</td>\n<td>27</td>\n</tr>\n<tr><td>W</td>\n<td>Week in month</td>\n<td>Number</td>\n<td>2</td>\n</tr>\n<tr><td>D</td>\n<td>Day in year</td>\n<td>Number</td>\n<td>189</td>\n</tr>\n<tr><td>d</td>\n<td>Day in month</td>\n<td>Number</td>\n<td>10</td>\n</tr>\n<tr><td>F</td>\n<td>Day of week in month</td>\n<td>Number</td>\n<td>2</td>\n</tr>\n<tr><td>E</td>\n<td>Day in week</td>\n<td>Text</td>\n<td>Tuesday; Tue</td>\n</tr>\n<tr><td>a</td>\n<td>Am/pm marker</td>\n<td>Text</td>\n<td>PM</td>\n</tr>\n<tr><td>H</td>\n      <td>Hour in day (0-23)</td>\n<td>Number</td>\n<td>0</td>\n</tr>\n<tr><td>k</td>\n      <td>Hour in day (1-24)</td>\n<td>Number</td>\n<td>24</td>\n</tr>\n<tr><td>K</td>\n<td>Hour in am/pm (0-11)</td>\n<td>Number</td>\n<td>0</td>\n</tr>\n<tr><td>h</td>\n<td>Hour in am/pm (1-12)</td>\n<td>Number</td>\n<td>12</td>\n</tr>\n<tr><td>m</td>\n<td>Minute in hour</td>\n<td>Number</td>\n<td>30</td>\n</tr>\n<tr><td>s</td>\n<td>Second in minute</td>\n<td>Number</td>\n<td>55</td>\n</tr>\n<tr><td>S</td>\n<td>Millisecond</td>\n<td>Number</td>\n<td>978</td>\n</tr>\n<tr><td>x/z</td>\n<td>Time zone</td>\n<td>General time zone</td>\n<td>Pacific Standard Time; PST; GMT-08:00</td>\n</tr>\n<tr><td>Z</td>\n<td>Time zone</td>\n<td>RFC 822 time zone</td>\n<td>-0800</td>\n</tr>\n</tbody>\n</table>\n\n","html_type":"<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>"},{"tagname":"params","type":"Object","name":"locale","doc":"<p>locale object</p>\n","html_type":"<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>"},{"tagname":"params","type":"Number","name":"timeZoneOffset","doc":"<p>time zone offset by minutes</p>\n","html_type":"<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>"}],"members":[{"name":"format","tagname":"method","owner":"KISSY.Date.Formatter","id":"method-format","meta":{}},{"name":"parse","tagname":"method","owner":"KISSY.Date.Formatter","id":"method-parse","meta":{}},{"name":"getDateInstance","tagname":"method","owner":"KISSY.Date.Formatter","id":"static-method-getDateInstance","meta":{"static":true}},{"name":"getDateTimeInstance","tagname":"method","owner":"KISSY.Date.Formatter","id":"static-method-getDateTimeInstance","meta":{"static":true}},{"name":"getInstance","tagname":"method","owner":"KISSY.Date.Formatter","id":"static-method-getInstance","meta":{"static":true}},{"name":"getTimeInstance","tagname":"method","owner":"KISSY.Date.Formatter","id":"static-method-getTimeInstance","meta":{"static":true}}],"alternateClassNames":[],"aliases":{},"id":"class-KISSY.Date.Formatter","short_doc":"date time formatter for KISSY gregorian date. ...","component":false,"superclasses":[],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Files</h4><div class='dependency'><a href='source/format.html#KISSY-Date-Formatter' target='_blank'>format.js</a></div></pre><div class='doc-contents'><p>date time formatter for KISSY gregorian date.</p>\n\n<pre class='inline-example '><code><a href=\"#!/api/KISSY-method-use\" rel=\"KISSY-method-use\" class=\"docClass\">KISSY.use</a>('date/format,date/gregorian',function(S, DateFormat, GregorianCalendar){\n     var calendar = new GregorianCalendar(2013,9,24);\n     // ' to escape\n     var formatter = new DateFormat(\"'today is' ''yyyy/MM/dd a''\");\n     document.write(formatter.format(calendar));\n });\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>pattern</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>patter string of date formatter</p>\n\n<table border=\"1\">\n<thead valign=\"bottom\">\n<tr><th class=\"head\">Letter</th>\n<th class=\"head\">Date or Time Component</th>\n<th class=\"head\">Presentation</th>\n<th class=\"head\">Examples</th>\n</tr>\n</thead>\n<tbody valign=\"top\">\n<tr><td>G</td>\n<td>Era designator</td>\n<td>Text</td>\n<td>AD</td>\n</tr>\n<tr><td>y</td>\n<td>Year</td>\n<td>Year</td>\n<td>1996; 96</td>\n</tr>\n<tr><td>M</td>\n<td>Month in year</td>\n<td>Month</td>\n<td>July; Jul; 07</td>\n</tr>\n<tr><td>w</td>\n<td>Week in year</td>\n<td>Number</td>\n<td>27</td>\n</tr>\n<tr><td>W</td>\n<td>Week in month</td>\n<td>Number</td>\n<td>2</td>\n</tr>\n<tr><td>D</td>\n<td>Day in year</td>\n<td>Number</td>\n<td>189</td>\n</tr>\n<tr><td>d</td>\n<td>Day in month</td>\n<td>Number</td>\n<td>10</td>\n</tr>\n<tr><td>F</td>\n<td>Day of week in month</td>\n<td>Number</td>\n<td>2</td>\n</tr>\n<tr><td>E</td>\n<td>Day in week</td>\n<td>Text</td>\n<td>Tuesday; Tue</td>\n</tr>\n<tr><td>a</td>\n<td>Am/pm marker</td>\n<td>Text</td>\n<td>PM</td>\n</tr>\n<tr><td>H</td>\n      <td>Hour in day (0-23)</td>\n<td>Number</td>\n<td>0</td>\n</tr>\n<tr><td>k</td>\n      <td>Hour in day (1-24)</td>\n<td>Number</td>\n<td>24</td>\n</tr>\n<tr><td>K</td>\n<td>Hour in am/pm (0-11)</td>\n<td>Number</td>\n<td>0</td>\n</tr>\n<tr><td>h</td>\n<td>Hour in am/pm (1-12)</td>\n<td>Number</td>\n<td>12</td>\n</tr>\n<tr><td>m</td>\n<td>Minute in hour</td>\n<td>Number</td>\n<td>30</td>\n</tr>\n<tr><td>s</td>\n<td>Second in minute</td>\n<td>Number</td>\n<td>55</td>\n</tr>\n<tr><td>S</td>\n<td>Millisecond</td>\n<td>Number</td>\n<td>978</td>\n</tr>\n<tr><td>x/z</td>\n<td>Time zone</td>\n<td>General time zone</td>\n<td>Pacific Standard Time; PST; GMT-08:00</td>\n</tr>\n<tr><td>Z</td>\n<td>Time zone</td>\n<td>RFC 822 time zone</td>\n<td>-0800</td>\n</tr>\n</tbody>\n</table>\n\n</div></li><li><span class='pre'>locale</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>locale object</p>\n</div></li><li><span class='pre'>timeZoneOffset</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>time zone offset by minutes</p>\n</div></li></ul></div><div class='members'><div class='members-section'><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div class='definedBy'>Defined By</div><h4 class='members-subtitle'>Instance methods</h3><div id='method-format' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='KISSY.Date.Formatter'>KISSY.Date.Formatter</span><br/><a href='source/format.html#KISSY-Date-Formatter-method-format' target='_blank' class='view-source'>view source</a></div><a href='#!/api/KISSY.Date.Formatter-method-format' class='name expandable'>format</a>( <span class='pre'>calendar</span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">string</a><span class=\"signature\"></span></div><div class='description'><div class='short'>format a GregorianDate instance according to specified pattern ...</div><div class='long'><p>format a GregorianDate instance according to specified pattern</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>calendar</span> : <a href=\"#!/api/KISSY.Date.Gregorian\" rel=\"KISSY.Date.Gregorian\" class=\"docClass\">KISSY.Date.Gregorian</a><div class='sub-desc'><p>GregorianDate instance</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">string</a></span><div class='sub-desc'><p>formatted string of GregorianDate instance</p>\n</div></li></ul></div></div></div><div id='method-parse' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='KISSY.Date.Formatter'>KISSY.Date.Formatter</span><br/><a href='source/format.html#KISSY-Date-Formatter-method-parse' target='_blank' class='view-source'>view source</a></div><a href='#!/api/KISSY.Date.Formatter-method-parse' class='name expandable'>parse</a>( <span class='pre'>dateStr</span> ) : <a href=\"#!/api/KISSY.Date.Gregorian\" rel=\"KISSY.Date.Gregorian\" class=\"docClass\">KISSY.Date.Gregorian</a><span class=\"signature\"></span></div><div class='description'><div class='short'>parse a formatted string of GregorianDate instance according to specified pattern ...</div><div class='long'><p>parse a formatted string of GregorianDate instance according to specified pattern</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>dateStr</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>formatted string of GregorianDate</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/KISSY.Date.Gregorian\" rel=\"KISSY.Date.Gregorian\" class=\"docClass\">KISSY.Date.Gregorian</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div></div><div class='subsection'><div class='definedBy'>Defined By</div><h4 class='members-subtitle'>Static methods</h3><div id='static-method-getDateInstance' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='KISSY.Date.Formatter'>KISSY.Date.Formatter</span><br/><a href='source/format.html#KISSY-Date-Formatter-static-method-getDateInstance' target='_blank' class='view-source'>view source</a></div><a href='#!/api/KISSY.Date.Formatter-static-method-getDateInstance' class='name expandable'>getDateInstance</a>( <span class='pre'>dateStyle, locale, timeZoneOffset</span> ) : <a href=\"#!/api/KISSY.Date.Gregorian\" rel=\"KISSY.Date.Gregorian\" class=\"docClass\">KISSY.Date.Gregorian</a><span class=\"signature\"><span class='static' >static</span></span></div><div class='description'><div class='short'>get a formatter instance of specified date style. ...</div><div class='long'><p>get a formatter instance of specified date style.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>dateStyle</span> : <a href=\"#!/api/KISSY.Date.Formatter.Style\" rel=\"KISSY.Date.Formatter.Style\" class=\"docClass\">KISSY.Date.Formatter.Style</a><div class='sub-desc'><p>date format style</p>\n</div></li><li><span class='pre'>locale</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>timeZoneOffset</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>time zone offset by minutes</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/KISSY.Date.Gregorian\" rel=\"KISSY.Date.Gregorian\" class=\"docClass\">KISSY.Date.Gregorian</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-getDateTimeInstance' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='KISSY.Date.Formatter'>KISSY.Date.Formatter</span><br/><a href='source/format.html#KISSY-Date-Formatter-static-method-getDateTimeInstance' target='_blank' class='view-source'>view source</a></div><a href='#!/api/KISSY.Date.Formatter-static-method-getDateTimeInstance' class='name expandable'>getDateTimeInstance</a>( <span class='pre'>dateStyle, timeStyle, locale, timeZoneOffset</span> ) : <a href=\"#!/api/KISSY.Date.Gregorian\" rel=\"KISSY.Date.Gregorian\" class=\"docClass\">KISSY.Date.Gregorian</a><span class=\"signature\"><span class='static' >static</span></span></div><div class='description'><div class='short'>get a formatter instance of specified date style and time style. ...</div><div class='long'><p>get a formatter instance of specified date style and time style.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>dateStyle</span> : <a href=\"#!/api/KISSY.Date.Formatter.Style\" rel=\"KISSY.Date.Formatter.Style\" class=\"docClass\">KISSY.Date.Formatter.Style</a><div class='sub-desc'><p>date format style</p>\n</div></li><li><span class='pre'>timeStyle</span> : <a href=\"#!/api/KISSY.Date.Formatter.Style\" rel=\"KISSY.Date.Formatter.Style\" class=\"docClass\">KISSY.Date.Formatter.Style</a><div class='sub-desc'><p>time format style</p>\n</div></li><li><span class='pre'>locale</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>timeZoneOffset</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>time zone offset by minutes</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/KISSY.Date.Gregorian\" rel=\"KISSY.Date.Gregorian\" class=\"docClass\">KISSY.Date.Gregorian</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-getInstance' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='KISSY.Date.Formatter'>KISSY.Date.Formatter</span><br/><a href='source/format.html#KISSY-Date-Formatter-static-method-getInstance' target='_blank' class='view-source'>view source</a></div><a href='#!/api/KISSY.Date.Formatter-static-method-getInstance' class='name expandable'>getInstance</a>( <span class='pre'>locale, timeZoneOffset</span> ) : <a href=\"#!/api/KISSY.Date.Gregorian\" rel=\"KISSY.Date.Gregorian\" class=\"docClass\">KISSY.Date.Gregorian</a><span class=\"signature\"><span class='static' >static</span></span></div><div class='description'><div class='short'>get a formatter instance of short style pattern. ...</div><div class='long'><p>get a formatter instance of short style pattern.\nen-us: M/d/yy h:mm a\nzh-cn: yy-M-d ah:mm</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>locale</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>locale object</p>\n</div></li><li><span class='pre'>timeZoneOffset</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>time zone offset by minutes</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/KISSY.Date.Gregorian\" rel=\"KISSY.Date.Gregorian\" class=\"docClass\">KISSY.Date.Gregorian</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-getTimeInstance' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='KISSY.Date.Formatter'>KISSY.Date.Formatter</span><br/><a href='source/format.html#KISSY-Date-Formatter-static-method-getTimeInstance' target='_blank' class='view-source'>view source</a></div><a href='#!/api/KISSY.Date.Formatter-static-method-getTimeInstance' class='name expandable'>getTimeInstance</a>( <span class='pre'>timeStyle, locale, timeZoneOffset</span> ) : <a href=\"#!/api/KISSY.Date.Gregorian\" rel=\"KISSY.Date.Gregorian\" class=\"docClass\">KISSY.Date.Gregorian</a><span class=\"signature\"><span class='static' >static</span></span></div><div class='description'><div class='short'>get a formatter instance of specified time style. ...</div><div class='long'><p>get a formatter instance of specified time style.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>timeStyle</span> : <a href=\"#!/api/KISSY.Date.Formatter.Style\" rel=\"KISSY.Date.Formatter.Style\" class=\"docClass\">KISSY.Date.Formatter.Style</a><div class='sub-desc'><p>time format style</p>\n</div></li><li><span class='pre'>locale</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>timeZoneOffset</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>time zone offset by minutes</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/KISSY.Date.Gregorian\" rel=\"KISSY.Date.Gregorian\" class=\"docClass\">KISSY.Date.Gregorian</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});